/*============================================================================
  File:     RestoreIndexInternals.sql

  Summary:  Restore the IndexInternals case study database
			(Employee Table Case Study)
  
  Date:     November 2008
------------------------------------------------------------------------------
  Written by Kimberly L. Tripp, SYSolutions, Inc.

  For more scripts and sample code, check out 
    http://www.SQLskills.com

  This script is intended only as a supplement to demos and lectures
  given by Kimberly L. Tripp.  
  
  THIS CODE AND INFORMATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF 
  ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED 
  TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A
  PARTICULAR PURPOSE.
============================================================================*/

-- These samples use the SQL Server 2008 "IndexInternals" database. 
-- Copy the IndexInternals2008.bak file to C:\SQLskills directory 
-- (or change line 56 to your specific path).
-- Also, change lines 59/61 to your specific instance's path.

-- NOTE: This is a compressed SQL Server 2008 backup.

-- This script takes about 20 seconds to execute

:ON ERROR EXIT
go

SET NOCOUNT ON
go

USE master
go

IF DATABASEPROPERTYEX('IndexInternals', 'Collation') IS NOT NULL
	ALTER DATABASE IndexInternals
		SET RESTRICTED_USER 
		WITH ROLLBACK IMMEDIATE
go

IF substring(convert(varchar, SERVERPROPERTY('ProductVersion')), 1, 2) <> '10' 
BEGIN
	RAISERROR('The IndexInternals backup can only be restored on SQL Server 2008', 16, -1)
	RETURN
END
go

IF substring(convert(varchar, SERVERPROPERTY('ProductVersion')), 1, 2) = '10' 
	RESTORE DATABASE [IndexInternals] 
	FROM  DISK = N'C:\SQLskills\IndexInternals2008.BAK' 
	WITH  FILE = 1,  
		MOVE N'IndexInternalsData' 
			TO N'c:\Program Files\Microsoft SQL Server\MSSQL10.SQLDev01\MSSQL\data\IndexInternalsData.mdf',  
		MOVE N'IndexInternalsLog' 
			TO N'c:\Program Files\Microsoft SQL Server\MSSQL10.SQLDev01\MSSQL\data\IndexInternalsLog.ldf',
	STATS = 10, REPLACE
go

IF DATABASEPROPERTYEX('IndexInternals', 'Collation') IS NOT NULL
	ALTER DATABASE IndexInternals
		SET MULTI_USER 
		WITH ROLLBACK IMMEDIATE
go