/*============================================================================
  File:     DynamicStringExecution v sp_executesql

  Summary:  Can you get optimal perf or not?
  
  Date:     October 2008

  SQL Server Version: 10.00.1600.22 (RTM)
------------------------------------------------------------------------------
  Written by Kimberly L. Tripp, SYSolutions, Inc.
  
  For more scripts and sample code, check out 
    http://www.SQLskills.com

  This script is intended only as a supplement to demos and lectures
  given by Kimberly L. Tripp.  
  
  THIS CODE AND INFORMATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF 
  ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED 
  TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A
  PARTICULAR PURPOSE.
============================================================================*/

SET STATISTICS IO ON
-- Turn Graphical Showplan ON (Ctrl+K)

DBCC FREEPROCCACHE       --Clears all plans from cache
DBCC DROPCLEANBUFFERS    --Clears all data from cache

select * from master.dbo.syscacheobjects
select * from sys.system_objects
where name like '[dm_]%'

SELECT st.text, qs.EXECUTION_COUNT, qs.*, p.* 
FROM sys.dm_exec_query_stats AS qs 
	CROSS APPLY sys.dm_exec_sql_text(sql_handle) st
	CROSS APPLY sys.dm_exec_query_plan(plan_handle) p
ORDER BY 1, qs.EXECUTION_COUNT DESC;

USE pubs
go

SELECT * FROM dbo.titles WHERE price = 17.99
SELECT * FROM dbo.titles WHERE price = 199.99
SELECT * FROM dbo.titles WHERE price = $19.99

-- or to force caching (caching by specification) 
-- use sp_executesql
DECLARE @ExecStr    nvarchar(4000)
SELECT @ExecStr = 'SELECT * FROM dbo.titles WHERE price = @price'
EXEC sp_executesql @ExecStr,
                      N'@price money',
                      199.99
                      
-- Dynamic String Execution vs sp_executesql
DECLARE @price      money,
        @ExecStr    nvarchar(4000)
SET @price = 19.99
SELECT @ExecStr = 'SELECT * FROM dbo.titles WHERE price = ' 
					+ convert(varchar(10), @price)
SELECT @ExecStr
EXEC(@ExecStr)
